| Flutter Impeller |

Public Types | Public Member Functions | List of all members
impeller::EntityPlayground Class Reference

`#include <entity_playground.h>`

Inheritance diagram for impeller::EntityPlayground:

## Public Types
using | EntityPlaygroundCallback = std::function< bool(ContentContext &context, RenderPass &pass)>
Public Types inherited from impeller::Playground
using | SinglePassCallback = std::function< bool(RenderPass &pass)>
using | RenderCallback = std::function< bool(RenderTarget &render_target)>
using | GLProcAddressResolver = std::function< void *(const char *proc_name)>
using | VKProcAddressResolver = std::function< void *(void *instance, const char *proc_name)>

## Public Member Functions
| EntityPlayground ()
| ~EntityPlayground ()
void | SetTypographerContext (std::shared_ptr< TypographerContext > typographer_context)
bool | OpenPlaygroundHere (Entity entity)
bool | OpenPlaygroundHere (EntityPlaygroundCallback callback)
std::shared_ptr< ContentContext > | GetContentContext () const
Public Member Functions inherited from impeller::PlaygroundTest
| PlaygroundTest ()
virtual | ~PlaygroundTest ()
void | SetUp () override
void | TearDown () override
PlaygroundBackend | GetBackend () const
std::unique_ptr< fml::Mapping > | OpenAssetAsMapping (std::string asset_name) const override
RuntimeStage::Map | OpenAssetAsRuntimeStage (const char *asset_name) const
std::string | GetWindowTitle () const override
Public Member Functions inherited from impeller::Playground
| Playground (PlaygroundSwitches switches)
virtual | ~Playground ()
void | SetupContext (PlaygroundBackend backend, const PlaygroundSwitches &switches)
void | SetupWindow ()
void | TeardownWindow ()
bool | IsPlaygroundEnabled () const
Point | GetCursorPosition () const
ISize | GetWindowSize () const
Point | GetContentScale () const
Scalar | GetSecondsElapsed () const
| Get the amount of time elapsed from the start of the playground's execution. More...
std::shared_ptr< Context > | GetContext () const
std::shared_ptr< Context > | MakeContext () const
bool | OpenPlaygroundHere (const RenderCallback &render_callback)
bool | OpenPlaygroundHere (SinglePassCallback pass_callback)
std::shared_ptr< Texture > | CreateTextureForFixture (const char *fixture_name, bool enable_mipmapping=false) const
std::shared_ptr< Texture > | CreateTextureCubeForFixture (std::array< const char *, 6 > fixture_names) const
fml::Status | SetCapabilities (const std::shared_ptr< Capabilities > &capabilities)
bool | WillRenderSomething () const
| Returns true if `OpenPlaygroundHere` will actually render anything. More...
GLProcAddressResolver | CreateGLProcAddressResolver () const
VKProcAddressResolver | CreateVKProcAddressResolver () const
void | SetGPUDisabled (bool disabled) const
| Mark the GPU as unavilable. More...

## Additional Inherited Members
Static Public Member Functions inherited from impeller::Playground
static bool | ShouldOpenNewPlaygrounds ()
static std::shared_ptr< CompressedImage > | LoadFixtureImageCompressed (std::shared_ptr< fml::Mapping > mapping)
static std::optional< DecompressedImage > | DecodeImageRGBA (const std::shared_ptr< CompressedImage > &compressed)
static std::shared_ptr< Texture > | CreateTextureForMapping (const std::shared_ptr< Context > &context, std::shared_ptr< fml::Mapping > mapping, bool enable_mipmapping=false)
static bool | SupportsBackend (PlaygroundBackend backend)
Protected Member Functions inherited from impeller::Playground
void | SetWindowSize (ISize size)
Protected Attributes inherited from impeller::Playground
const PlaygroundSwitches | switches_

## Detailed Description

Definition at line 16 of file entity_playground.h.

## Member Typedef Documentation

## ◆ EntityPlaygroundCallback

using impeller::EntityPlayground::EntityPlaygroundCallback = std::function<bool(ContentContext& context, RenderPass& pass)>

Definition at line 18 of file entity_playground.h.

## Constructor & Destructor Documentation

## ◆ EntityPlayground()

impeller::EntityPlayground::EntityPlayground | ( |  | ) |

Definition at line 13 of file entity_playground.cc.

14 : typographer_context_(TypographerContextSkia::Make()) {}
impeller::TypographerContextSkia::Make
static std::shared_ptr< TypographerContext > Make()
Definition: typographer_context_skia.cc:76

## ◆ ~EntityPlayground()

impeller::EntityPlayground::~EntityPlayground | ( |  | ) |
| default

## Member Function Documentation

## ◆ GetContentContext()

std::shared_ptr< ContentContext > impeller::EntityPlayground::GetContentContext | ( |  | ) | const

Definition at line 23 of file entity_playground.cc.

23 {
24 return std::make_shared<ContentContext>(GetContext(), typographer_context_);
25 }
impeller::Playground::GetContext
std::shared_ptr< Context > GetContext() const
Definition: playground.cc:91

References impeller::Playground::GetContext().

Referenced by impeller::testing::BlendFilterContentsTest::MakeTexture(), impeller::testing::GaussianBlurFilterContentsTest::MakeTexture(), impeller::testing::MatrixFilterContentsTest::MakeTexture(), and OpenPlaygroundHere().

## ◆ OpenPlaygroundHere() [1/2]

bool impeller::EntityPlayground::OpenPlaygroundHere | ( | Entity | entity | ) |

Definition at line 27 of file entity_playground.cc.

27 {
28 if (!switches_.enable_playground) {
29 return true;
30 }
31
32 auto content_context = GetContentContext();
33 if (!content_context->IsValid()) {
34 return false;
35 }
36 SinglePassCallback callback = [&](RenderPass& pass) -> bool {
37 content_context->GetRenderTargetCache()->Start();
38 bool result = entity.Render(*content_context, pass);
39 content_context->GetRenderTargetCache()->End();
40 content_context->GetTransientsBuffer().Reset();
41 return result;
42 };
43 return Playground::OpenPlaygroundHere(callback);
44 }
impeller::EntityPlayground::GetContentContext
std::shared_ptr< ContentContext > GetContentContext() const
Definition: entity_playground.cc:23
impeller::Playground::OpenPlaygroundHere
bool OpenPlaygroundHere(const RenderCallback &render_callback)
Definition: playground.cc:201
impeller::Playground::SinglePassCallback
std::function< bool(RenderPass &pass)> SinglePassCallback
Definition: playground.h:50
impeller::Playground::switches_
const PlaygroundSwitches switches_
Definition: playground.h:131
impeller::PlaygroundSwitches::enable_playground
bool enable_playground
Definition: switches.h:17

References impeller::PlaygroundSwitches::enable_playground, GetContentContext(), impeller::Playground::OpenPlaygroundHere(), impeller::Entity::Render(), and impeller::Playground::switches_.

## ◆ OpenPlaygroundHere() [2/2]

bool impeller::EntityPlayground::OpenPlaygroundHere | ( | EntityPlaygroundCallback | callback | ) |

Definition at line 46 of file entity_playground.cc.

46 {
47 if (!switches_.enable_playground) {
48 return true;
49 }
50
51 ContentContext content_context(GetContext(), typographer_context_);
52 if (!content_context.IsValid()) {
53 return false;
54 }
55 SinglePassCallback pass_callback = [&](RenderPass& pass) -> bool {
56 content_context.GetRenderTargetCache()->Start();
57 bool result = callback(content_context, pass);
58 content_context.GetRenderTargetCache()->End();
59 content_context.GetTransientsBuffer().Reset();
60 return result;
61 };
62 return Playground::OpenPlaygroundHere(pass_callback);
63 }

References impeller::PlaygroundSwitches::enable_playground, impeller::Playground::GetContext(), impeller::ContentContext::GetRenderTargetCache(), impeller::ContentContext::GetTransientsBuffer(), impeller::ContentContext::IsValid(), impeller::Playground::OpenPlaygroundHere(), impeller::HostBuffer::Reset(), and impeller::Playground::switches_.

## ◆ SetTypographerContext()

void impeller::EntityPlayground::SetTypographerContext | ( | std::shared_ptr< TypographerContext > | typographer_context | ) |

Definition at line 18 of file entity_playground.cc.

19 {
20 typographer_context_ = std::move(typographer_context);
21 }

The documentation for this class was generated from the following files:

- impeller/entity/entity_playground.h
- impeller/entity/entity_playground.cc